local ammo_table = {}
currentWeapon = nil
local cd = false
local reloadCooldown = false -- Variabilă pentru cooldown la reîncărcare
local reloadNotify = false -- Variabilă pentru notificarea de cooldown

RegisterCommand('testax', function()
    print(json.encode(ammo_table))
end)

local function isWeaponBig(model)
    for _, bigWeapon in pairs(Config.bigweaponslist) do
        if model == bigWeapon then
            return true
        end
    end
    return false
end

local function VehicleInFront()
    local player = PlayerPedId()
    local pos = GetEntityCoords(player)
    local entityWorld = GetOffsetFromEntityInWorldCoords(player, 0.0, 2.0, 0.0)
    local rayHandle = CastRayPointToPoint(pos.x, pos.y, pos.z, entityWorld.x, entityWorld.y, entityWorld.z, 30, player, 0)
    local _, _, _, _, result = GetRaycastResult(rayHandle)
    return result
end

function vRPin.equipWeapon(weapon, anim)
    local ped = PlayerPedId()
    if IsPedInAnyVehicle(ped, false) then
        return
    end
    if cd then
        return
    end

    cd = true
    SetTimeout(1000, function() cd = false end)

    local selectedWeapon = GetSelectedPedWeapon(ped)
    local vehicle = VehicleInFront()
    local can = false

    if isWeaponBig(weapon) then
        if GetPedDrawableVariation(PlayerPedId(), 5) ~= 0 then
            can = true
        end
        if GetVehiclePedIsIn(ped, false) == 0 and DoesEntityExist(vehicle) and IsEntityAVehicle(vehicle) and not can then
            can = true
        end
        if can then
        end
    else
        can = true
    end

    if currentWeapon == weapon and vRPin.get_rob_status() then
        if anim then
            vRP.playAnim({true, {{"reaction@intimidation@1h", "outro", 1}}, false})
            Citizen.Wait(1600)
            ClearPedTasks(ped)
        end
        if currentWeapon then
            local currentAmmo = GetAmmoInPedWeapon(ped, GetHashKey(currentWeapon))
            RemoveWeaponFromPed(ped, GetHashKey(weapon))
            ammo_table[currentWeapon] = currentAmmo
        end
        currentWeapon = nil
        vRPin.notify({name = weapon, count = 1, label = Config.Items[weapon][1]}, "ASCUNSA")
        return
    end

    if currentWeapon == weapon and selectedWeapon ~= GetHashKey('WEAPON_UNARMED') then
        if anim then
            vRP.playAnim({true, {{"reaction@intimidation@1h", "outro", 1}}, false})
            Citizen.Wait(1600)
            ClearPedTasks(ped)
        end
        if currentWeapon then
            local currentAmmo = GetAmmoInPedWeapon(ped, GetHashKey(currentWeapon))
            RemoveWeaponFromPed(ped, GetHashKey(weapon))
            ammo_table[currentWeapon] = currentAmmo
        end
        currentWeapon = nil
        vRPin.notify({name = weapon, count = 1, label = Config.Items[weapon][1]}, "ASCUNSA")
    elseif can then
        TriggerServerEvent('3dme:triggerDisplay', me_txt)
        if me_txt == "" then
            SetVehicleDoorOpen(vehicle, 5, false, false)
        end
        if currentWeapon then
            local currentAmmo = GetAmmoInPedWeapon(ped, GetHashKey(currentWeapon))
            ammo_table[currentWeapon] = currentAmmo
        end
        RemoveAllPedWeapons(ped, true)
        currentWeapon = weapon

        if anim then
            vRP.playAnim({true, {{"reaction@intimidation@1h", "intro", 1}}, false})
            Citizen.Wait(1600)
            ClearPedTasks(ped)
        end

        GiveWeaponToPed(ped, GetHashKey(weapon), 0, false, true)
        if ammo_table[currentWeapon] then
            SetAmmoInClip(ped, GetHashKey(currentWeapon), tonumber(ammo_table[currentWeapon]))
        end
        vRPin.notify({name = weapon, count = 1, label = Config.Items[weapon][1]}, "SCOASA")
        if me_txt == "" then
            SetVehicleDoorShut(vehicle, 5, false)
        end
    else
        vRP.notify{"Aceasta arma poate fi scoasa doar din geanta/masina"}
    end
end

function vRPin.remove_weapon(item)
    if ammo_table[item] then
        if ammo_table[item] > 0 and item ~= currentWeapon then
            INserver.holstered({item, ammo_table[item]})
            ammo_table[item] = nil
        end
    end

    if item == currentWeapon then
        vRPin.equipWeapon(currentWeapon, true)
        INserver.holstered({item, ammo_table[item]})
        ammo_table[item] = nil
    end
    return currentWeapon
end

function vRPin.clearAmmo()
    ammo_table = {}
end

RegisterCommand('reload', function()
    if currentWeapon ~= nil then
        if reloadCooldown then -- Verificăm dacă cooldown-ul este activ
            if not reloadNotify then
                vRP.notify{"Cooldown activ, așteaptă câteva momente!"}
                reloadNotify = true -- Activăm notificarea
            end
            return
        end
        
        local ped = PlayerPedId()
        local magazineSize = GetMaxAmmoInClip(ped, GetHashKey(currentWeapon))
        INserver.requestReload({currentWeapon, 1}, function(ok)
            if ok then
                SetPedAmmo(ped, GetHashKey(currentWeapon), magazineSize)
                ammo_table[currentWeapon] = magazineSize
                MakePedReload(ped)

                reloadCooldown = true -- Activăm cooldown-ul
                Citizen.Wait(2000) -- Durata cooldown-ului
                reloadCooldown = false -- Deactivăm cooldown-ul
                reloadNotify = false -- Resetăm notificarea

                Citizen.Wait(2000) -- Așteptăm pentru animația de reîncărcare
                ClearPedTasks(ped)
            end
        end)
    end
end)
RegisterKeyMapping('reload', 'Incarca arma', 'keyboard', 'R')

Citizen.CreateThread(function()
    while true do
        Citizen.Wait(100)
        if currentWeapon ~= nil then
            local ped = PlayerPedId()
            local currentAmmo = GetAmmoInPedWeapon(ped, GetHashKey(currentWeapon))
            if currentAmmo < 1 then
                GiveWeaponToPed(ped, GetHashKey(currentWeapon), 0, false, true)
            end

            if vRP.isInComa({}) or vRP.isHandcuffed{} or vRP.isJailed({}) then
                currentWeapon = nil
                RemoveAllPedWeapons(PlayerPedId(), true)
            end
        else
            Citizen.Wait(1600)
        end
    end
end)
